#!/bin/bash

###########################
# mp3-genre-group.sh v0.5 #
###########################
#
# This little thingy will change the group of the dir to that of the genre
# listed in the .message-file made by zipscript-c.
# Run in crontab or whatever.
# Meant to work with mp3-dirs, ofcourse.
# As always, my script comes with no guarantees.
#
# Yes, I know this script suffers from a "bad name", like the rest of my
# script. Who cares! ;)
#
# New in v0.5
# -----------
# Bugfixes. Optimization. Cleanup.

##########################################
# The config - change to the appropriate #
##########################################

# Your GLFTPD root-dir
glftpd_dir="/glftpd"

# Where do you keep your MP3's?
glftpd_mp3="/site/MP3"

# The name of your dated dir. Don't worry - it will work with non-dated dirs
# as well. (see example commented)
dated_format="%m%d"
#dated_format="ARCHIVE"

# Here's a list of days backward it will make changes... 3 days ago, 2 days ago,
# yesterday and today are the defaults. Check the date-command for more info.
daysback="3 2 1 0"
#daysback="1 0"

# Should the script create a .message file in the root of the dated dir, where it
# lists the name of all dirs, sorted by genre?
create_message="Y"
#create_message="N"

# These next two variables should be changes if you have changed the m3u settings
# in your zipscript-c, or use a different m3u extractor. In the .message-file in
# the mp3-dir, the name of the genre is normally prefixed by a word (Genre) and a
# delimeter (:). If the genre is Hip-Hip, you'll find something like this in the
# .message:
# |     Genre    : Hip-Hop
# These variables allow you to change the word and delimeter, so the script may
# recognize it, and be able to extract the genre. In norwegian, you could perhaps
# use the following:
# delimeter=">>"
# name_genre="Sjanger"
# |     Sjanger >> Hip-Hop
# If this make no meaning to you whatsoever, or you have not made any particular
# modifications to the m3u-extraction, leave the two variables as is.
delimeter=":"
name_genre="Genre"

#################
# End of Config #
#################

# no need to change below

# this sub will do the mod
check_it() {
 if [ ! -z "$genre" ]; then
  if [ -z "`cat $glftpd_dir/etc/group | tr ' ' '_' | awk -F ":" '{ print $1 }' | grep -e "$genre"`" ]; then
   grp_num=`tail -n 1 $glftpd_dir/etc/group | tr ' ' '_' | awk -F ":" '{ print $1 ":" $3 }' | awk -F ":" '{ print $2 }'`
   if [ ! $grp_num -lt $grp_largest ]; then
    grp_largest=$grp_num
   fi
   grp=`expr $grp_largest \+ 100`
   echo "$genre:MP3:$grp:" >> $glftpd_dir/etc/group
   echo "$genre:MP3:$grp:" >> $glftpd_dir/etc/group-
  else
   grp="`cat $glftpd_dir/etc/group | tr ' ' '_' | awk -F ":" '{ print $1 ":" $3 }' | tr 'A-Z' 'a-z' | grep -e "$genre" | head -n 1`"
   if [ ! -z "$grp" ]; then
    grp="`echo $grp | awk -F ":" '{ print $2 }'`";
    chgrp $grp $work_dir/$dir
   fi
  fi
 fi
}

grp_largest="100"
bsddays="d"
if [ `date -v 3d >/dev/null 2>&1; echo $?` -gt 0 ]; then
 os_type="linux"
else
 os_type="fbsd"
fi
for dayback in $daysback; do
 if [ "$os_type" = "linux" ]; then
  work_dir="${glftpd_dir}${glftpd_mp3}/`date --date="$dayback days ago" +"$dated_format"`"
 else
  work_dir="${glftpd_dir}${glftpd_mp3}/`date -v -$dayback$bsddays +"$dated_format"`"
 fi
 if [ -e $work_dir ]; then
  for dir in `ls -1F $work_dir | grep -e "/$" | tr -d '/'`; do
   if [ -e $work_dir/$dir/.message ]; then
    genre="`cat $work_dir/$dir/.message | grep -iw "$name_genre" | awk -F "$delimeter" '{ print $2 }' | awk '{ print $1 }' | tr 'A-Z' 'a-z'`"
    if [ ! -z "$genre" ]; then
     echo "$genre : $dir" >> $work_dir/.message.temp
     check_it
    fi
   else
    for subdir in `ls -1F $work_dir/$dir | grep -e "/$" | tr -d '/'`; do
     if [ -e $work_dir/$dir/$subdir/.message ]; then
      genre="`cat $work_dir/$dir/$subdir/.message | grep -iw "$name_genre" | awk -F "$delimeter" '{ print $2 }' | awk '{ print $1 }' | tr 'A-Z' 'a-z'`"
      if [ ! -z "$genre" ]; then
       echo "$genre : $dir" >> $work_dir/.message.temp
       check_it
      fi
     fi
    done
   fi
  done
  if [ -e $work_dir/.message.temp ]; then
   if [ ! "$create_message" = "N" ]; then
    cat $work_dir/.message.temp | sort -n > $work_dir/.message
   fi
   rm $work_dir/.message.temp
  fi
 fi
done
